require File.join(File.dirname(__FILE__), '..', 'helpers', 'ng_option_utils')

module FormAngular
  module  Errors
    module NgError
      include NgOptionUtils

      def ng_error(wrapper_options)
        error_tags = ""
        error_tags = template.content_tag(:span, "{{errors['#{tag_name}'].server}}", html_options("server"))
        if @options[:ng_errors]
          @options[:ng_errors].each do |validate_key|
            error_tags += template.content_tag(:span, I18n.t("activerecord.errors.#{lookup_model_names.last}.#{attribute_name}.#{validate_key}"), html_options(validate_key))
          end
        end
        error_tags
      end

      def has_html_error
        ng_error.present?
      end

      def html_options(key)
        html_options ||= {}
        html_options.merge!({'ng-show' => "#{ng_access_expression}.$error.#{key} && (#{ng_access_expression}.$invalid || #{ng_access_expression}.$dirty)", class: "ng-cloak text-danger"})
      end
    end
  end
end

SimpleForm::Inputs::Base.send(:include, FormAngular::Errors::NgError)
