module FormAngular
  module Fields
    module NgModelInput
      extend ActiveSupport::Concern
      include NgOptionUtils

      included do
        alias_method_chain :initialize, :ng_model
      end

      def initialize_with_ng_model(builder, attribute_name, column, input_type, options = {})
        initialize_without_ng_model(builder, attribute_name, column, input_type, options)
        input_html_options.merge! build_angular_options(attribute_name, @builder) if is_ng_form?
      end

      def is_ng_form?
        return @builder.options[:ngform] if @builder.options[:ngform].present?
        parent_builder = @builder.options[:parent_builder]
        #Find a parent builder with ngform
        until !parent_builder || parent_builder.options[:ngform].present?
          parent_builder = parent_builder.options[:parent_builder]
        end
        return parent_builder && parent_builder.options[:ngform]
      end
    end
  end
end

SimpleForm::Inputs::Base.send :include, FormAngular::Fields::NgModelInput
