module FormAngular
  module Forms
    module NgForm
      extend ActiveSupport::Concern
      include NgOptionUtils

      included do
        alias_method_chain :simple_form_for, :ng_model
      end

      def simple_form_for_with_ng_model(record, options = {}, &block)
        if options[:ngform]
          options[:html] ||= {}
          options[:html] = build_angular_form_options(record).merge! options[:html]
          options[:fields_context] = form_context(record)
        end

        simple_form_for_without_ng_model(record, options, &block)
      end
    end
  end
end

SimpleForm::ActionViewExtensions::FormHelper.send :include, FormAngular::Forms::NgForm
