module FormAngular
  module NgOptionUtils
    extend ActiveSupport::Concern

    included do

      def build_angular_form_options(record)
        angular_options = {
          name: "#{form_context(record)}Form",
          novalidate: true
        }
      end


      def build_angular_options(attribute_name, builder)
        begin
          names = builder.object_name.gsub(/\[(?<wat>[a-zA-Z][_a-zA-Z0-9]+)+\]/, '.\k<wat>').gsub("_attributes", '').split(".")
          names[0] = names[0].camelize(:lower)
          angular_options = {
            'ng-model' => "#{names.join(".")}.#{attribute_name}",
            'server-error' => "true"
          }
        rescue => e
        end
      end

      def form_context(record)
        record.class.name.camelize(:lower)
      end

      def context_name(record)
        if record.is_a?(String) || record.is_a?(Symbol)
          record
        else
          record.class.name.underscore
        end
      end

      #Find a better way to make the form name trickledown globally in the wrapper api
      def form_name
        name = from_html_options(:name, @builder.options)
        return name unless name.blank?
        builder = @builder
        until !builder || !name.blank?
          name = from_html_options(:name, builder.options)
          builder = builder.options[:parent_builder]
        end
        name
      end

      def from_html_options(key, html_options)
        if html_options[:html]
          html_options[:html][key]
        end
      end

      def ng_access_expression
        "#{form_name}['#{tag_name}']"
      end

      def ng_form_expression
        "#{form_name}"
      end

      def tag_name(multiple = false)
        "#{object_name}[#{attribute_name}]"
      end
    end
  end
end
